Subject: RE: [P2PSIP] RE: [Simple] Do we need to introduce SIMPLEinto P2Ptorealize presence and IM services?

From: "Willekens, Marc" <[email-masked]>
Date: Fri, 6 Jul 2007 21:57:40 +0200

It's good to see the evolution of the consensus around p2p and that it's not the Holy Grail which will solve everything. "A one size fits all" approach will not work in the "real world".

The SIP/SIMPLE certainly has to be considered in a p2p environment, but not as the only and only one solution but as part of different deployment models such as:
1. Large ISP model with a world coverage (ca. 10.000.000 users)
2. Medium Operator Model which is mostly still country related (ca. 1000.000 users)
3. Small Community model (ca. 100.000 users)
4. Tiny Personality model (ca. 100 users)

These different deployment models have their own advantages and disadvantages. For the large, medium and small model, a "central presence server" is mostly provided which can make use of mass of scale advantages and certain traffic optimization techniques such as an RLS. This is the point of view from the clients making use of the presence system. The central server can make use of clustering, load balancing and p2p distributed concepts. The '"trust" is completely provided (or not provided) in the "closed domain". In case something is wrong, you know where to go to with your complaints.

In the "Tiny Personality Model", each end-device or an own more reliable computing resource provides its own presence server for the own presentity and subscriptions from watchers are handled by the functionality provided by the end-ueser resource. Each client owns and controls its own server. In this model, there is a "peer-to-peer" relationship but a p2p protocol is not used to distribute the presence data over different peers to avoid the problems with trust and reliability as indicated already by Jonathan. However, this system combined with the p2pSIP gives an end-user the ability to build up its own network without the need of being dependent on an ISP, Network operator or an Enterprise. This certainly has advantages in different use cases, e.g. for ad-hoc kind of networking, a small virtual team with worldwide members, etc...

A requirement for the end-device is the ability to be part of the different deployments in parallel with a uniform user experience and interface. That's why open standards are needed!  Much of the inter-domain scaling problems can then be avoided because the different domain acceses are handled by the end-devices.

Br,
Marc.

-----Original Message-----
From: ext Vikas Tandon [mailto:[email-masked]] 
Sent: vrijdag 6 juli 2007 5:25
To: 'Jonathan Rosenberg'; 'Henry Sinnreich'
Cc: [email-masked]; [email-masked]
Subject: RE: [P2PSIP] RE: [Simple] Do we need to introduce SIMPLEinto P2Ptorealize presence and IM services?

A significant aspect of P2P vs Client/Server(CSP) is the ability to use
Presence as a service in the network and other services like presence based
call routing. Under this aspect e, a Client Server Model plays a significant
role.

Some other considerations are:
1. Looking at the memory and processing requirements in P2P mode, the client
needs to process more information (e.g. keep track of every buddy's client
capabilities, service capability etc.). 
2. Another aspect of P2P is the offline messages for which you'd need some
kind of server which monitors presence/online status of message inbox.
3. Also in context of wireless devices, it makes more sense to have a CSP
model since coverage and connectivity are a practical issue today (e.g. in a
2.5G network, I'm supposed to receive an IM from a buddy but I'm on a voice
call and the message is not delivered to me because my GPRS is suspended due
to voice call - who will store and retransmit the message to me the moment
I'm available again?)

I'd think of a combination of P2P and CSP model providing more value as
opposed to a single protocol.

regards,
Vikas

-----Original Message-----
From: Jonathan Rosenberg [mailto:[email-masked]] 
Sent: Friday, July 06, 2007 4:37 AM
To: Henry Sinnreich
Cc: Song Yongchao; Beck01, Wolfgang; [email-masked];
[email-masked]; [email-masked]
Subject: Re: [P2PSIP] RE: [Simple] Do we need to introduce SIMPLE into
P2Ptorealize presence and IM services?

There are definitely a lot of questions to be addressed in making SIMPLE
work in a p2p system.

One the question of RLS services, I would tend to think that they are not
needed in a p2p system. The whole premise of RLS services is that the server
has access to a much richer set of bandwidth and processing resources. So,
let it do the 'fan-out' work of processing the buddy list and managing the
dialogs. In a p2p model, the 'server' would be just another client on the
ring. SO there is no reason to expect that it is any better suited to
perform the task.

MOst of the issues, I think, are really around security and authorization.
Part of a presence server's role is to perform privacy processing - to limit
who can subscribe and to limit what data they can see. In a client/server
system, the presence server can perform this role since the client trusts
its server to do so. In a p2p system, would you trust some other node in the
network to execute your privacy preferences? I think not.

So, rather, I think that, while online, a user's own user agent would have
to supply the presence for the user. While offline, they would store a
presence document that all would have access to, which indicates some
limited form of offline access. Thus, a user is their own presence server.
That eliminates the need for tools like XCAP and presence authorization
policy documents, since know the user and their presence server are
colocated.

As always, multiple devices are a challenge....

-Jonathan R.

Henry Sinnreich wrote:
> Can anyone share a comparison for presence using P2P vs. using SIMPLE 
> client-server?
> 
> At first glance it looks obvious that P2P SIMPLE is the answer, but an 
> analysis would be of great help.
> 
> Thanks, Henry
> 
> -----Original Message----- From: Song Yongchao 
> [mailto:[email-masked]] Sent: Wednesday, July 04, 2007 7:51 PM
>  To: 'Beck01, Wolfgang' Cc: [email-masked]; [email-masked]; 
> [email-masked] Subject: RE: [P2PSIP] RE: [Simple] Do we need to 
> introduce SIMPLE into P2Ptorealize presence and IM services?
> 
> I agree with that. The draft
> http://www.ietf.org/internet-drafts/draft-ietf-simple-interdomain-
> scaling-analysis-00.txt has shown the complexity and the load that the 
> presence server has to handle in order to provide its service.
> Self-organization infrastructure may help with the scalability of C/S  
> presence by utilizing the processing resource of the end users.
> Using an application layer multicast and uri list message should be a 
> good choice.
> 
> Sure, there are many questions to be considered, including offline 
> messages, churn of the p2p network, the presentity's policies, the 
> durability and availability of the presence information in P2P network 
> and security considerations.
> 
> 
> 
> Best Regards! Song Yongchao
> 
> -----Original Message----- From: Beck01, Wolfgang 
> [mailto:[email-masked]] Sent: 2007年7月2日 19:25 To:
> [email-masked]; [email-masked]; [email-masked] Cc:
> [email-masked] Subject: AW: [P2PSIP] RE: [Simple] Do we need to 
> introduce SIMPLE into P2P torealize presence and IM services?
> 
> Presence scalability is an issue even with C/S SIP. The real 
> difficulty with NOTIFY is that different watchers may see different 
> presence documents, due to the presentity's policies. Off-line 
> presence brings further complications.
> 
> Some random thoughts:
> 
> If a group of watchers receives the same presence document, an 
> application layer multicast may distribute the load between devices.
> Could draft-ietf-sip-uri-list-message be abused for this purpose? A 
> peer receiving a NOTIFY with a recipient-list forwards it to some 
> contacts mentioned there (removing those contacts from the 
> recipient-list before sending). Possible, but I don't want to write 
> the Security Considerations section..
> 
> Offline presence can be done by storing a user's presence document 
> like a file in P2P file sharing networks. To meet the presentity's 
> policy, we would need some elaborate encryption scheme, so that 
> watchers can only those parts they are allowed to see. Multiple 
> versions of the presence document might be necessary, one for every 
> watcher/presentity pair.
> 
> 
> Wolfgang
> 
> 
> 
> 
> _______________________________________________ P2PSIP mailing list 
> [email-masked] https://www1.ietf.org/mailman/listinfo/p2psip
> 
> _______________________________________________ P2PSIP mailing list 
> [email-masked] https://www1.ietf.org/mailman/listinfo/p2psip
> 

-- 
Jonathan D. Rosenberg, Ph.D.                   600 Lanidex Plaza
Cisco Fellow                                   Parsippany, NJ 07054-2711
Cisco Systems
[email-masked]                              FAX:   (973) 952-5050
http://www.jdrosen.net                         PHONE: (973) 952-5000
http://www.cisco.com

_______________________________________________
Simple mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/simple

_______________________________________________
P2PSIP mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/p2psip